//---------------------------------------------------------------------------
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include "memory.h"
//---------------------------------------------------------------------------
void MemoryFromFile::Read(long pos)
{
lseek(fd,pos,SEEK_SET);

if ((length=read(fd,p,size-2))<0)
   MyError(ReadFailed);

position=pos;
p[length]='\n';
p[length+1]=0;
p[size-2]=0;
}
//---------------------------------------------------------------------------
char * MemoryFromFile::Pointer2Line(long handle, unsigned int pos)
{
char * tmp;

handle+=pos;

if ((handle<position) || (handle>=position+size-2))
	{
taki_da:
    	Read(handle);
	if (length)
		return(p);
	else
		return(NULL);
	}

if (length+position-handle<=0)
	return(NULL);

tmp=p+handle-position;
if (length+position-handle>LINE_SIZE)
	return(tmp);

if (strchr(tmp,'\n')!=NULL)
	return(tmp);

if (length<size-2)
	return(tmp);

goto taki_da;
}
//---------------------------------------------------------------------------
void MemoryFromFile::Close()
{
close(fd);
}
//---------------------------------------------------------------------------
void MemoryFromFile::Open(char * path)
{
if ((fd=open(path,O_RDONLY|O_BINARY))<0)		//O_BINARY
   MyError(OpenFailed,path);
}
//---------------------------------------------------------------------------
MemoryFromFile::~MemoryFromFile()
{
free(p);
}
//---------------------------------------------------------------------------
MemoryFromFile::MemoryFromFile(unsigned int maxsize, unsigned int minsize)
{
position=length=0;
while (maxsize>=minsize)
      {
      if ((p=(char*)malloc(maxsize))!=NULL)
      	 {
         size=maxsize;
         return;
         }
      maxsize/=2;
      }
MyError(NoMemory);
}
//---------------------------------------------------------------------------
MemoryFromMemory::~MemoryFromMemory()
{}
//---------------------------------------------------------------------------
Memory::~Memory()
{}
//---------------------------------------------------------------------------
MemoryFromMemory::MemoryFromMemory(long hnd, char * bound, Memory * prnt)
{
handle=hnd;
strncpy(boundary,bound,LINE_SIZE-1);
boundary[LINE_SIZE-1]=0;
strlenofboundary=strlen(boundary);
parent=prnt;
}
//---------------------------------------------------------------------------
char * MemoryFromMemory::Pointer2Line(long hnd, unsigned int pos)
{
char *p;

hnd+=pos;

if ((p=parent->Pointer2Line(handle, (unsigned int)hnd))==NULL)
	return(NULL);

if ((strncmp(p,boundary,strlenofboundary)==0) && ((p[strlenofboundary]=='\n') || (p[strlenofboundary]=='\r')))
	return(NULL);

return(p);
}
//---------------------------------------------------------------------------

